;***************************************************************************************************************

;This software is provided in an AS IS condition,NO WARRANTIES in any form apply to this software.

; picmicrolab.com 5.22.2017
;***************************************************************************************************************
;BCD to 7 Segment Display Decoder PIC16F876A
;
;--------------------------------------------------------------------------------------------------------------	
		LIST 	P=PIC16F876A
		include	P16f876A.inc

 __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _LVP_OFF & _DEBUG_OFF & _CPD_OFF

	    org		0x00
reset:	goto start
	    org		0x04
start:

	bsf			STATUS, RP0
	bcf			STATUS, RP1
	clrf		TRISC
	;bsf			TRISB,0x04 ;LED Test
	;bsf			TRISB,0x05 ;LED Blanking
	bsf			TRISC,0x07 ;LED Latch Input
	movlw		0xff
	movwf		TRISB;BCD Inputs
	bcf			STATUS, RP0
	movlw		0xff ;	Clear Display
	movwf		PORTC

;----------------------------------------------------
;movf	0x41,w ;Load Counter value to Converter
;movwf	0x40 ;Data to be converted to 7-Segment Code
movlw 0x01
movwf 0x40;Temp register for converted BCD Code


LOOP:
;-------------------Test if LED Blanking enabled RB5
btfsc	PORTB,0x05
goto	LEDTEST
movlw	0xff ;	Clear Display
movwf	PORTC
goto	LOOP
;-----------------------------------------------------

LEDTEST:
;-------------------Test if LED Test enabled RB4
btfsc	PORTB,0x04
goto	convert
movlw   0x08
movwf 	0x40
call    ConvertBCDto7Segment
goto	LEDTEST
;-----------------------------------------------------
convert:
movlw 0x0f;Isolate Lower 4 bits of PORTB
andwf PORTB,w
;-----If Latch Enabled send new value to display
btfss	PORTC,0x07
movwf 	0x40
call    ConvertBCDto7Segment 
goto   	LOOP 
;movwf 0x40
;---------------------------------------------
;call    ConvertBCDto7Segment 

;goto   LOOP  

;------------------------------------
ConvertBCDto7Segment:

movf 0x40,w
sublw 0x01
btfss STATUS,Z ; 1
goto Digit2
movlw	0xf9
movwf	PORTC
return
;------------------------------------
Digit2:
movf 0x40,w
sublw 0x02
btfss STATUS,Z ; 2
goto Digit3
movlw	0xA4
movwf	PORTC
return
;---------------------------
Digit3:
movf 0x40,w
sublw 0x03
btfss STATUS,Z ; 3
goto Digit4
movlw	0xb0
movwf	PORTC
return

;---------------------------
Digit4:
movf 0x40,w
sublw 0x04
btfss STATUS,Z ; 4
goto Digit5
movlw	0x99
movwf	PORTC
return
;---------------------------
Digit5:
movf 0x40,w
sublw 0x05
btfss STATUS,Z ; 5
goto Digit6
movlw	0x92
movwf	PORTC
return
;---------------------------
Digit6:
movf 0x40,w
sublw 0x06
btfss STATUS,Z ; 6
goto Digit7
movlw	0x82
movwf	PORTC
return
;---------------------------
Digit7:
movf 0x40,w
sublw 0x07
btfss STATUS,Z ; 7
goto Digit8
movlw	0xf8
movwf	PORTC
return
;----------------------------
Digit8:
movf 0x40,w
sublw 0x08
btfss STATUS,Z ; 8
goto Digit9
movlw	0x80
movwf	PORTC
return
;---------------------------
Digit9:
movf 0x40,w
sublw 0x09
btfss STATUS,Z ; 9
goto Digit0
movlw	0x90
movwf	PORTC
return
;---------------------------
Digit0:
movf 0x40,w
btfss STATUS,Z ; 0
return
movlw	0xc0
movwf	PORTC
return
;---------------------------

end